
package net.mcreator.mnthings.item;

import net.minecraftforge.registries.ObjectHolder;

import net.minecraft.world.World;
import net.minecraft.item.UseAction;
import net.minecraft.item.Rarity;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.Item;
import net.minecraft.item.Food;
import net.minecraft.entity.LivingEntity;

import net.mcreator.mnthings.procedures.FreezedmeatFoodEatenProcedure;
import net.mcreator.mnthings.MnthingsModElements;

import java.util.Map;
import java.util.HashMap;

@MnthingsModElements.ModElement.Tag
public class FreezedmeatItem extends MnthingsModElements.ModElement {
	@ObjectHolder("mnthings:freezedmeat")
	public static final Item block = null;
	public FreezedmeatItem(MnthingsModElements instance) {
		super(instance, 9);
	}

	@Override
	public void initElements() {
		elements.items.add(() -> new FoodItemCustom());
	}
	public static class FoodItemCustom extends Item {
		public FoodItemCustom() {
			super(new Item.Properties().group(ItemGroup.FOOD).maxStackSize(64).rarity(Rarity.COMMON)
					.food((new Food.Builder()).hunger(4).saturation(0.8f).meat().build()));
			setRegistryName("freezedmeat");
		}

		@Override
		public UseAction getUseAction(ItemStack itemstack) {
			return UseAction.EAT;
		}

		@Override
		public ItemStack onItemUseFinish(ItemStack itemstack, World world, LivingEntity entity) {
			ItemStack retval = super.onItemUseFinish(itemstack, world, entity);
			double x = entity.getPosX();
			double y = entity.getPosY();
			double z = entity.getPosZ();
			{
				Map<String, Object> $_dependencies = new HashMap<>();
				$_dependencies.put("entity", entity);
				FreezedmeatFoodEatenProcedure.executeProcedure($_dependencies);
			}
			return retval;
		}
	}
}
